/*global fetch */
//
// Section: CSE 154
// Sample JSON Test code.
//

"use strict";
(function(){



    /**
     * Call the initialize fuction when the onload event happens
     */
    window.onload = function(){
        $("jsonTestBtn").onclick = getJsonData;
    };



    /**
     * Event handler to get the JSON data.
     */
    function getJsonData(){
        let url = "jsontest.php";

        fetch(url, {credentials: "include"}) // include credentials for cloud9
           .then(checkStatus)
           .then(JSON.parse)
           .then(loadData)
           .catch(alert);
    }


    /**
     * Function to load the JSON data into the document
     * @param data - the data that is being returned from the API in JSON format
     *
     */
    function loadData(data) {
        let response = $("response");
        response.innerText = data["name"];
        let p = document.createElement("p");
        p.innerText = "Hobbies";
        response.appendChild(p);
        let ul = document.createElement("ul");
        response.appendChild(ul);
        for(let i = 0; i < data["hobbies"].length; i++) {
            let li = document.createElement("li");
            li.innerText = data["hobbies"][i];
            ul.appendChild(li);
        }
    }


   /**
     *  Shortcut to get the document element by id
     *  @param the string value of the ID of the DOM element you are getting
     *  @return the DOM element with that particular ID
     */
    function $(id) {
     return document.getElementById(id);
    }



    /**
     * Function to check the status of an Ajax call, boiler plate code to include,
     * based on: https://developers.google.com/web/updates/2015/03/introduction-to-fetch
     * @param the response text from the url call
     * @return did we succeed or not, so we know whether or not to continue with the handling of
     * this promise
     */
    function checkStatus(response) {
        if (response.status >= 200 && response.status < 300) {
            return response.text();
        } else {
            return Promise.reject(new Error(response.status+": " + response.statusText));
        }
    }

})();
